/*
 * FrameRenderer.cpp
 *
 */

#include <iostream>
#include "FrameRenderer.h"

FrameRenderer::FrameRenderer(Timer* t) : subj(t) {
	subj->subscribe(this);
}

FrameRenderer::~FrameRenderer() {
	subj->unsubscribe(this);
}

void FrameRenderer::displayFrame() {
	std::cout << "Display decompressed frame" << std::endl;
}

void FrameRenderer::update() {
	if ((subj->getMilliseconds() % 40) == 0) {
		displayFrame();
	}
}
