/*
 * Timer.cpp
 *
 */

#include "Timer.h"

Timer::Timer() : milliseconds(0), restarted(false) {
}

Timer::~Timer() {
}

void Timer::tick() {
	milliseconds += 10;
	notify();
}

void Timer::subscribe(Observer* o) {
	observers.push_back(o);
}

void Timer::unsubscribe(Observer* o) {
	observers.remove(o);
}

void Timer::setMilliseconds(long value) {
	milliseconds = value;
	notify();
}

void Timer::setRestarted(bool r) {
	restarted = r;
	notify();
}

void Timer::notify() {
	std::list<Observer*>::iterator itr;
	for (itr = observers.begin(); itr != observers.end(); itr++) {
		(*itr)->update();
	}
}

