/*
 * Timer.h
 *
 */

#ifndef TIMER_H_
#define TIMER_H_

#include <list>
#include "Subject.h"

class Timer: public Subject {
public:
	Timer();
	virtual ~Timer();

	virtual void subscribe(Observer* o);
	virtual void unsubscribe(Observer* o);
	virtual void notify();

	void tick();
	void restart();

	long getMilliseconds() const {
		return milliseconds;
	}
	bool isRestarted() const {
		return restarted;
	}
	void setMilliseconds(long value);
	void setRestarted(bool r);

private:
	long milliseconds;
	bool restarted;

	std::list<Observer*> observers;
};

#endif /* TIMER_H_ */
