/*
 * videoplayer.cpp
 *
 */

#include <iostream>

#include "Timer.h"
#include "FrameRenderer.h"
#include "Slider.h"

int main() {
	std::cout << "Observer - Pull" << std::endl;
	// create subject
	Timer clock;
	// create observers. Pass the address of the subject, to let them register themselves
	FrameRenderer display(&clock);
	Slider* progressBar = new Slider(&clock);
	// update the state of the subject
	clock.setRestarted(false);
	for (int i = 0; i < 10; i++) {
		if (i == 5)
			clock.setRestarted(true);
		if (i == 6)
			clock.setRestarted(false);
		clock.tick();
	}
	// dynamically change the number of observers
	delete progressBar;
	// continue to update the state of the subject
	for (int i = 0; i < 6; i++)
		clock.tick();

}
